function Face(t){// t_v = tableau de vecteurs : les sommets.
    this.sommets = [];
    this.sommetsAux = [];
    for(var i = 0; i < t.length; i++){
      this.sommets[i] = t[i];
      //this.sommetsAux[i] = createVector(t[i].x, t[i].y, t[i].z);
    }
    this.init();
}

Face.prototype.init = function(){
    this.normale = createVector(0, 0, 0);
    this.centre = createVector(0, 0, 0);
    this.rayons = [];
    this.translationNum = 0;
    this.translation = createVector(0, 0, 0);
    this.transparence = 0;
    this.echelle = 1;
    this.couleur = color(0);
    this.visible = true;
    this.etoile = false;
    this.t = 0; // pourcentage de trou
    this.pourcent = 0.5; // rentrée d'étoile
    this.partieDeLaFigure = true;

    for(var i = 0; i < this.sommets.length; i++){
      this.sommetsAux[i] = createVector(this.sommets[i].x, this.sommets[i].y, this.sommets[i].z);
    }

    this.calculNormale();
    this.calculCentre();
    this.calculRayons();
}

Face.prototype.display = function(){
  var sommetsPlus = [];
  var newSommets = [];
  if (this.visible && this.partieDeLaFigure){
    fill(this.couleur);
    noStroke();
    var sAL = this.sommetsAux.length;
    var newCentre = p5.Vector.add(this.centre, this.translation);
    var newRayons = [];
    for(var i = 0; i < sAL; i++){
      newRayons[i] = p5.Vector.mult(this.rayons[i], this.echelle);
      newSommets[i] = p5.Vector.add(newCentre, newRayons[i]);
    }
    if(this.etoile){
      for(var i = 0; i < sAL; i++){
          var r, s;
          if (i < sAL - 1 ){
            r = p5.Vector.add(newRayons[i], newRayons[i+1]);
          }else{
            r = p5.Vector.add(newRayons[i], newRayons[0]);
          }
          r.mult(0.5*this.pourcent);
          s = p5.Vector.add(newCentre, r);
          sommetsPlus[i] = s;
      }
    }

    for(i = 0; i < sAL; i++){
      if (this.etoile){// c'est une étoile
        if(this.t > 0){// elle est trouée
          quad(newSommets[i].x, newSommets[i].y, newSommets[i].z,
                sommetsPlus[i].x, sommetsPlus[i].y, sommetsPlus[i].z,
                this.t*newSommets[i].x+(1-this.t)*newCentre.x,
                this.t*newSommets[i].y+(1-this.t)*newCentre.y,
                this.t*newSommets[i].z+(1-this.t)*newCentre.z,
                this.t*sommetsPlus[i].x+(1-this.t)*newCentre.x,
                this.t*sommetsPlus[i].y+(1-this.t)*newCentre.y,
                this.t*sommetsPlus[i].z+(1-this.t)*newCentre.z);
        }else{// Elle n'est pas trouée
          triangle(newCentre.x, newCentre.y, newCentre.z,
                  newSommets[i].x, newSommets[i].y, newSommets[i].z,
                  sommetsPlus[i].x, sommetsPlus[i].y, sommetsPlus[i].z);
        }
        if(this.t > 0){
          quad(sommetsPlus[i].x, sommetsPlus[i].y, sommetsPlus[i].z,
              newSommets[(i+1)%sAL].x, newSommets[(i+1)%sAL].y, newSommets[(i+1)%sAL].z,
              this.t*sommetsPlus[i].x+(1-this.t)*newCentre.x,
              this.t*sommetsPlus[i].y+(1-this.t)*newCentre.y,
              this.t*sommetsPlus[i].z+(1-this.t)*newCentre.z,
              this.t*newSommets[(i+1)%sAL].x+(1-this.t)*newCentre.x,
              this.t*newSommets[(i+1)%sAL].y+(1-this.t)*newCentre.y,
              this.t*newSommets[(i+1)%sAL].z+(1-this.t)*newCentre.z);
        }else{
          triangle(newCentre.x, newCentre.y, newCentre.z,
                  sommetsPlus[i].x, sommetsPlus[i].y, sommetsPlus[i].z,
                  newSommets[(i+1)%sAL].x, newSommets[(i+1)%sAL].y, newSommets[(i+1)%sAL].z);
        }

      }else { // pas étoile
        if(this.t > 0){ // trouée
          quad(newSommets[i].x, newSommets[i].y, newSommets[i].z,
               newSommets[(i+1)%sAL].x, newSommets[(i+1)%sAL].y, newSommets[(i+1)%sAL].z,
               this.t*newSommets[i].x+(1-this.t)*newCentre.x,
               this.t*newSommets[i].y+(1-this.t)*newCentre.y,
               this.t*newSommets[i].z+(1-this.t)*newCentre.z,
               this.t*newSommets[(i+1)%sAL].x+(1-this.t)*newCentre.x,
               this.t*newSommets[(i+1)%sAL].y+(1-this.t)*newCentre.y,
               this.t*newSommets[(i+1)%sAL].z+(1-this.t)*newCentre.z);
        }else{// pas trouée
          triangle(newCentre.x, newCentre.y, newCentre.z,
                  newSommets[i].x, newSommets[i].y, newSommets[i].z,
                  newSommets[(i+1)% sAL].x, newSommets[(i+1)% sAL].y, newSommets[(i+1)% sAL].z);
        }
      }
    }
  }
 }


Face.prototype.calculNormale = function(){
  var max = createVector(0, 0, 0);
  var lg = this.sommetsAux.length;
  for(var i = 0; i < lg; i++){
    var u, v, o, n;
    var j = (i+1) % lg;
    var k = (i+2) % lg;
    u = this.sommetsAux[i].copy();
    o = this.sommetsAux[j];
    v = this.sommetsAux[k].copy();
    u.sub(o);
    v.sub(o);
    n = u.cross(v);
    if (n.mag() > max.mag()){max = n;}
  }
  max.normalize();
  this.normale = max;
}

Face.prototype.calculCentre = function(){
  var totalX = 0, totalY = 0, totalZ = 0;
  var l = this.sommetsAux.length;
  for(var i = 0; i < l; i++){
    totalX += this.sommetsAux[i].x;
    totalY += this.sommetsAux[i].y;
    totalZ += this.sommetsAux[i].z;
  }
  this.centre = createVector(totalX/l, totalY/l, totalZ/l);
}

Face.prototype.calculRayons = function(){
  for(var i = 0; i < this.sommetsAux.length; i++){
    var u = this.sommetsAux[i].copy();
    u.sub(this.centre);
    this.rayons[i] = u;
  }
}

Face.prototype.modifierSommet = function(i, v){
  var u = this.sommetsAux[i];
  if((u.x === v.x) && (u.y === v.y) && (u.z === v.z)){return;}
  this.sommetsAux[i] = v.copy();
  this.calculNormale();
  this.calculCentre();
  this.calculRayons();
}

Face.prototype.setTranslationN = function(t){
  this.translationNum = t;
  this.translation = p5.Vector.mult(this.normale, t);
  //console.log('setT');
}

Face.prototype.setEchelle = function(e){
  this.echelle = abs(e);
}

Face.prototype.setPourCentTrou = function(u){
  this.t = min(max(0, u), 1);
}

// À faire tous les getters et setters
// Fin classe "Face"
//***********************************************
